//---------------------------------------------------------------------------

#ifndef ModifyConponentFmH
#define ModifyConponentFmH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Buttons.hpp>
#include <Dialogs.hpp>
#include <stdio.h>
#include <Inifiles.hpp>
#include <math.h>
#include "TypInfo.hpp"

#define CH  1
#define ENG 2
#define JP  3

#define smNone  0
#define smMove  1
#define smLeft  2
#define smRight 4
#define smUp    8
#define smDown  16
//---------------------------------------------------------------------------
class TModifyConponentForm : public TForm
{
__published:	// IDE-managed Components
   TStatusBar *StatusBar1;
   TGroupBox *GBFontStyle;
   TGroupBox *GBComponentPos;
   TSpeedButton *btnComponentUp;
   TSpeedButton *btnComponentLeft;
   TSpeedButton *btnComponentRight;
   TSpeedButton *btnComponentDown;
   TEdit *edComponentShift;
   TRadioButton *RBBlod;
   TRadioButton *RBItalic;
   TRadioButton *RBUnderline;
   TRadioButton *RBStrikeOut;
   TComboBox *CBSize;
   TLabel *Label1;
   TRadioButton *RBNormal;
   TRadioButton *RBPosMove;
   TRadioButton *RBSizeChange;
   TButton *btnSave;
   TButton *btnLoad;
   TComboBox *CBFormSelect;
   TListBox *LBComponentSelect;
   TLabel *Label3;
   TLabel *Label4;
   TButton *btnModifyFormClose;
   void __fastcall CBFormSelectChange(TObject *Sender);
   void __fastcall LBComponentSelectMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
   void __fastcall AdjustComponentPosition(TObject * Sender);
   void __fastcall ComponentStyleChange(TObject * Sender);
   void __fastcall CBSizeChange(TObject *Sender);
   void __fastcall FormShow(TObject *Sender);
   void __fastcall btnSaveClick(TObject *Sender);
   void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
   void __fastcall btnLoadClick(TObject *Sender);
   void __fastcall btnModifyFormCloseClick(TObject *Sender);
   void __fastcall btnSaveMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
private:	// User declarations
   TPanel *DisPanel[8];

public:		// User declarations
   __fastcall TModifyConponentForm(TComponent* Owner);
   void __fastcall GetValue(AnsiString sTmp, int & FontStyle, int & FontSize, int & Left, int & Top, int & Width, int & Height);
   void __fastcall InitialModifyParameter();
   void __fastcall ChangeLanguage();
   void __fastcall ChangCharset(int LangSwitch);
   void __fastcall PosMouseMove(TObject *Sender, TShiftState Shift, int X, int Y);
   void __fastcall PosMouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y);
   void __fastcall PosMouseUp(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y);
   void __fastcall SizeMouseMove(TObject *Sender, TShiftState Shift, int X, int Y);
   void __fastcall SizeMouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y);
   void __fastcall SizeMouseUp(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y);
   void __fastcall ReDrawDragStop();
   void __fastcall CreateDragStop(AnsiString Loc, TCursor Cur);
   void __fastcall SetDragStopPos(int Left, int Top, AnsiString Loc);

   TClass ClassRef;
   TListBox **ComponentList;
   AnsiString ComStyleFileName,sComponentStyle;
   PPropInfo PropInfo;
   TObject *DisplayForm;
   TMethod *tmpMethod[4];

   int FontStyle,FontSize,FLeft,FTop,FWidth,FHeight;
   int dx,dy;
   AnsiString LangFileName;
};

class TFocusComponent : public TControl
{
//NTControlUprotectedݩܬpublic
public:
   __property Color;
   __property Font;
   __property Caption;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
   __property OnClick ;
};
//---------------------------------------------------------------------------
extern PACKAGE TModifyConponentForm *ModifyConponentForm;
extern PACKAGE TFocusComponent *FocusComponent;
//---------------------------------------------------------------------------
#endif
